%define __global_requires_exclude_from  /usr/libexec

Summary: AI auto tuning system
Name: atune
Version: 1.0.0
Release: 12
License: Mulan PSL v2
URL: https://gitee.com/openeuler/A-Tune
Source: https://gitee.com/openeuler/A-Tune/repository/archive/v%{version}.tar.gz

Patch9000: check-whether-the-certificate-file-exists.patch
Patch9001: add-FAQ-and-self-signature-certificate-manufacturing.patch
Patch9002: fix-start-failed-of-atuned-service.patch
Patch9003: change-Makefile-A-Tune-version-to-1.0.0.patch
Patch9004: A-Tune-Add-sw64-architecture.patch
Patch9005: 0001-bugfix-transfer-can-only-save-file-to-specified-dir.patch
Patch9006: 0002-bugfix-training-model-can-only-save-file-to-specifie.patch
Patch9007: 0003-bugfix-collection-res-can-only-save-file-to-specifie.patch
Patch9008: 0004-atune-add-service-restart-mode.patch
Patch9009: 0005-atune-update-Makefile-and-logs.patch

BuildRequires: rpm-build golang-bin procps-ng
BuildRequires: sqlite >= 3.24.0 openssl
BuildRequires: python3-scikit-optimize python3-pandas python3-xgboost
BuildRequires: python3-pyyaml
BuildRequires: systemd
Requires: systemd
Requires: atune-client
Requires: atune-db
Requires: python3-dict2xml
Requires: python3-flask-restful
Requires: python3-pandas
Requires: python3-pyyaml
%ifarch aarch64
Requires: prefetch_tuning
%endif
Requires: perf
Requires: sysstat
Requires: hwloc-gui
Requires: psmisc
Requires: atune-collector

%define  debug_package %{nil}

%description
atune is a service for atuned AI tuning system.

%package client
Summary: client tool for auto tuning system
License: MuLan PSL v2

%description client
atune client tool for manage atuned AI tuning system.

%package db
Summary: database and AI model for auto tuning system
License: MuLan PSL v2

%description db
Database and AI model used by atuned AI tuning system.

%package engine
Summary: engine tool for auto tuning system
License: MuLan PSL v2
Requires: python3-scikit-optimize
Requires: python3-xgboost
Requires: python3-flask-restful
Requires: python3-pandas
Requires: python3-lhsmdu
Conflicts: atune < 0.3-0.9

%description engine
atune engine tool for manage atuned AI tuning system.

%prep
%autosetup -n A-Tune-v%{version} -p1
%ifarch sw_64
sed -i 's/-buildmode=plugin//g' Makefile
%endif
%ifarch loongarch64
# Replace atune's own sys with the sys provided by golang
cp -af %{_prefix}/lib/golang/src/cmd/vendor/golang.org/x/sys vendor/golang.org/x/
%endif

%build
%make_build

%install
%make_install

%check

%post
%systemd_post atuned.service

%preun
%systemd_preun atuned.service

%postun
%systemd_postun_with_restart atuned.service

%post engine
%systemd_post atune-engine.service

%preun engine
%systemd_preun atune-engine.service

%postun engine
%systemd_postun_with_restart atune-engine.service

%files
%license License/LICENSE
%defattr(0640,root,root,0750)
%attr(0550,root,root) /usr/lib/atuned/modules/daemon_profile_server.so
%attr(0640,root,root) %{_unitdir}/atuned.service
%attr(0550,root,root) %{_bindir}/atuned
%attr(0550,root,root) /usr/libexec/atuned/analysis/*
/usr/lib/atuned/profiles/*
%exclude /usr/libexec/atuned/analysis/app_engine.py
%exclude /usr/libexec/atuned/analysis/models/
%exclude /usr/libexec/atuned/analysis/optimizer/
%exclude /usr/libexec/atuned/analysis/engine/
%exclude /usr/libexec/atuned/analysis/dataset/
%attr(0750,root,root) %dir /usr/lib/atuned
%attr(0550,root,root) %dir /usr/lib/atuned/modules
%attr(0750,root,root) %dir /usr/lib/atuned/profiles
%attr(0750,root,root) %dir /usr/libexec/atuned
%attr(0550,root,root) %dir /usr/libexec/atuned/analysis
%attr(0750,root,root) %dir /usr/share/atuned
%attr(0750,root,root) %dir /etc/atuned
%attr(0750,root,root) %dir /etc/atuned/rules
%attr(0750,root,root) %dir /etc/atuned/tuning
%attr(0750,root,root) %dir /var/atuned
%attr(0640,root,root) /etc/atuned/atuned.cnf
%attr(0700,root,root) %dir /etc/atuned/engine_certs
%attr(0700,root,root) %dir /etc/atuned/rest_certs
%exclude /etc/atuned/engine_certs/*
%exclude /etc/atuned/rest_certs/*


%files client
%attr(0550,root,root) %{_bindir}/atune-adm
%attr(0550,root,root) /usr/share/bash-completion/completions/atune-adm

%files db
%attr(0750,root,root) %dir /var/lib/atuned
%attr(0750,root,root) %dir /var/run/atuned
%attr(0640,root,root) /var/lib/atuned/atuned.db
%attr(0750,root,root) %dir /usr/libexec/atuned
%attr(0550,root,root) %dir /usr/libexec/atuned/analysis
%attr(0550,root,root) %dir /usr/libexec/atuned/analysis/models
%attr(0550,root,root) /usr/libexec/atuned/analysis/models/*

%files engine
%license License/LICENSE
%defattr(0640,root,root,0750)
%attr(0640,root,root) %{_unitdir}/atune-engine.service
%attr(0550,root,root) /usr/libexec/atuned/analysis/*
/etc/atuned/*
%exclude /usr/libexec/atuned/analysis/app_rest.py
%exclude /usr/libexec/atuned/analysis/plugin/
%exclude /usr/libexec/atuned/analysis/atuned/
%attr(0550,root,root) %dir /usr/libexec/atuned/analysis
%attr(0750,root,root) %dir /etc/atuned
%exclude /etc/atuned/atuned.cnf
%exclude /etc/atuned/rules
%exclude /etc/atuned/tuning
%attr(0700,root,root) %dir /etc/atuned/engine_certs
%exclude /etc/atuned/engine_certs/*
%exclude /etc/atuned/rest_certs

%changelog
* Wed Aug 16 2023 gaoruoshu <gaoruoshu@huawei.com> - 1.0.0-12
- atune update Makefile and logs

* Wed Aug 16 2023 gaoruoshu <gaoruoshu@huawei.com> - 1.0.0-11
- atune add service restart mode

* Fri Aug 11 2023 panchenbo <panchenbo@kylinsec.com.cn> - 1.0.0-10
- update sw_64 support patch

* Fri Aug 11 2023 panchenbo <panchenbo@kylinsec.com.cn> - 1.0.0-9
- add support for loongarch64

* Thu Aug 10 2023 gaoruoshu <gaoruoshu@huawei.com> - 1.0.0-8
- bugfix set collection/transfer/train dir to specific dir

* Fri Apr 21 2023 yuxiangyang <yuxiangyang4@xfusion.com> - 1.0.0-7
- fix atune-engine process remaining after remove atune-engine.rpm

* Fri Mar 3 2023 wuzx<wuzx1226@qq.com> - 1.0.0-6
- Add sw64 architecture

* Sat Jan 28 2023 panxiaohe <pan_xiaohe@hoperun.com> - 1.0.0-5
- fix build failure that unitdir cannot be identified

* Fri Mar 04 2022 Bin Hu <hubin73@huawei.com> - 1.0.0-4
- change Makefile A-Tune version to 1.0.0

* Thu Mar 03 2022 gaoruoshu <gaoruoshu@huawei.com> - 1.0.0-3
- fix start failed of atuned service

* Tue Feb 15 2022 gaoruoshu <gaoruoshu@huawei.com> - 1.0.0-2
- enable certificate authentication by default and modify file permissions

* Fri Feb 18 2022 hanxinke <hanxinke@huawei.com> - 1.0.0-1
- upgrade to v1.0.0

* Wed Sep 29 2021 gaoruoshu <gaoruoshu@huawei.com> - 0.3-1.0
- atune-adm check error before atune-adm profile

* Mon Aug 30 2021 gaoruoshu <gaoruoshu@huawei.com> - 0.3-0.9
- add successExitStatus 100 to atuned.service

* Sat Mar 20 2021 BruceGW <gyl93216@163.com> - 0.3-0.8
- add go compile flag

* Mon Jan 11 2021 gaoruoshu <gaoruoshu@huawei.com> - 0.3-0.7
- update file description and test case

* Wed Dec 30 2020 HW_TaoChen <boby.chen@huawei.com> - 0.3-0.6
- support for go 1.15

* Sat Nov 28 2020 hanxinke<hanxinke@huawei.com> - 0.3-0.5
- The engine package conflicts with atune < 0.3-0.1.

* Mon Nov 9 2020 hanxinke<hanxinke@huawei.com> - 0.3-0.4
- fix wrong license

* Wed Sep 9 2020 Zhipeng Xie<xiezhipeng1@huawei.com> - 0.3-0.3
- only require prefetch_tuning on aarch64

* Mon Sep 7 2020 Zhipeng Xie<xiezhipeng1@huawei.com> - 0.3-0.2
- fix wrong requires

* Fri Sep 4 2020 Zhipeng Xie<xiezhipeng1@huawei.com> - 0.3-0.1
- upgrade to v0.3

* Thu Mar 19 2020 openEuler Buildteam <buildteam@openeuler.org> - 0.2-0.1
- Package init

* Tue Nov 12 2019 openEuler Buildteam <buildteam@openeuler.org> - 0.1-0.1
- Package init

